unit AgeLabel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TAgeLabel = class(TCustomLabel)
  private
    fYear,fMonth: Integer;
    function GetValue: Integer;
    procedure SetValue(const Value: Integer);
    function GetMonth: Integer;
    function GetYear: Integer;
    procedure SetMonth(const Value: Integer);
    procedure SetYear(const Value: Integer);
    procedure SetText;
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent);override;
  published
    { Published declarations }
    property Value: Integer read GetValue write SetValue;
    property Year: Integer read GetYear write SetYear;
    property Month: Integer read GetMonth write SetMonth;
    property Align;
    property Alignment;
    property Anchors;
    property AutoSize;
    property BiDiMode;
    property Color;
    property Constraints;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property FocusControl;
    property Font;
    property ParentBiDiMode;
    property ParentColor;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowAccelChar;
    property ShowHint;
    property Transparent;
    property Layout;
    property Visible;
    property WordWrap;
    property OnClick;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDock;
    property OnStartDrag;
  end;

procedure Register;

implementation
{$R *.res}
procedure Register;
begin
  RegisterComponents('Age Suit', [TAgeLabel]);
end;

{ TAgeLabel }

constructor TAgeLabel.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
        fYear := 0;
        fMonth := 0;
        SetText;
end;

function TAgeLabel.GetMonth: Integer;
begin
        Result := fMonth;
end;

function TAgeLabel.GetValue: Integer;
begin
        Result := fYear*12+fMonth;
end;

function TAgeLabel.GetYear: Integer;
begin
        Result := fMonth;
end;

procedure TAgeLabel.SetMonth(const Value: Integer);
begin
        fMonth := Value;
        if fMonth > 11 then fMonth := 11;
        if fMonth < 0 then fMonth := 0;
        SetText;
end;

procedure TAgeLabel.SetText;
begin
        Self.Caption := FormatFloat('00',fYear)+' year(s) '+FormatFloat('00',fMonth)+' month(s)';
end;

procedure TAgeLabel.SetValue(const Value: Integer);
begin
        fYear := Value div 12;
        fMonth := Value mod 12;
        SetText;
end;

procedure TAgeLabel.SetYear(const Value: Integer);
begin
        fYear := Value;
        if fYear > 99 then fYear := 99;
        if fYear < 0 then fYear := 0;
        SetText;
end;

end.
