unit DBAgeLabel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DBCtrls, DB;

type
  TDBAgeLabel = class(TCustomLabel)
  private
    FDataLink: TFieldDataLink;
    fYear, fMonth: Integer;
    procedure SetText;
    function GetDataField: string;
    function GetDataSource: TDataSource;
    procedure SetDataField(const Value: string);
    procedure SetDataSource(const Value: TDataSource);
    { Private declarations }
  protected
    { Protected declarations }
    procedure DataChange(Sender: TObject);
    procedure ActiveChange(Sender: TObject);
  public
    { Public declarations }
    constructor Create(AOwner: TComponent);override;
    destructor Destroy;override;    
  published
    { Published declarations }
    property DataSource: TDataSource read GetDataSource write SetDataSource;
    property DataField: string read GetDataField write SetDataField;
    property Align;
    property Alignment;
    property Anchors;
    property AutoSize;
    property BiDiMode;
    property Color;
    property Constraints;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property FocusControl;
    property Font;
    property ParentBiDiMode;
    property ParentColor;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowAccelChar;
    property ShowHint;
    property Transparent;
    property Layout;
    property Visible;
    property WordWrap;
    property OnClick;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDock;
    property OnStartDrag;
  end;

procedure Register;

implementation
{$R *.res}
procedure Register;
begin
  RegisterComponents('Age Suit', [TDBAgeLabel]);
end;

{ TDBAgeLabel }

procedure TDBAgeLabel.ActiveChange(Sender: TObject);
begin
        if FDataLink.DataSet.Active then begin
                fYear := FDataLink.Field.AsInteger div 12;
                fMonth := FDataLink.Field.AsInteger mod 12;
        end
        else begin
                fYear := 0;
                fMonth := 0;
        end;
        SetText;
end;

constructor TDBAgeLabel.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
        FDataLink := TFieldDataLink.Create;
        FDataLink.OnActiveChange := ActiveChange;
        FDataLink.OnDataChange := DataChange;
        fYear := 0;
        fMonth := 0;
        SetText;
end;

procedure TDBAgeLabel.DataChange(Sender: TObject);
begin
        if FDataLink.DataSet.Active then begin
                fYear := FDataLink.Field.AsInteger div 12;
                fMonth := FDataLink.Field.AsInteger mod 12;
        end
        else begin
                fYear := 0;
                fMonth := 0;
        end;
        SetText;
end;

destructor TDBAgeLabel.Destroy;
begin
        FDataLink.Free;
        FDataLink := nil;
  inherited Destroy;

end;

function TDBAgeLabel.GetDataField: string;
begin
  Result := FDataLink.FieldName;
end;

function TDBAgeLabel.GetDataSource: TDataSource;
begin
  Result := FDataLink.DataSource;
end;

procedure TDBAgeLabel.SetDataField(const Value: string);
begin
//  if not (csDesigning in ComponentState) then
  FDataLink.FieldName := Value;
end;

procedure TDBAgeLabel.SetDataSource(const Value: TDataSource);
begin
  if not (FDataLink.DataSourceFixed and (csLoading in ComponentState)) then
    FDataLink.DataSource := Value;
  if Value <> nil then Value.FreeNotification(Self);
end;

procedure TDBAgeLabel.SetText;
begin
        Self.Caption := FormatFloat('00',fYear)+' year(s) '+FormatFloat('00',fMonth)+' month(s)';
end;

end.
